---
title: Document.createProcessingInstruction()
slug: Web/API/Document/createProcessingInstruction
tags:
  - API
  - DOM
  - Document
  - Method
  - Reference
  - createProcessInstruction
---
<div>{{APIRef("DOM")}}</div>

<p><span class="seoSummary"><code>createProcessingInstruction()</code> generates a new <a href="/en-US/docs/Web/API/ProcessingInstruction">processing instruction</a> node and returns it.</span></p>

<p>The new node usually will be inserted into an XML document in order to accomplish anything with it, such as with {{ domxref("node.insertBefore") }}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush:js"><var>piNode</var> = <var>document</var>.createProcessingInstruction(<var>target</var>, <var>data</var>)
</pre>

<h3 id="Parameters">Parameters</h3>

<ul>
 <li><code><var>piNode</var></code> is the resulting {{ domxref("ProcessingInstruction") }} node.</li>
 <li><code><var>target</var></code> is a string containing the first part of the processing instruction (i.e., <code>&lt;?<strong><var>target</var></strong> … ?&gt;</code>)</li>
 <li><code><var>data</var></code> is a string containing any information the processing instruction should carry, after the target. The data is up to you, but it can't contain <code>?&gt;</code>, since that closes the processing instruction.</li>
</ul>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>DOM_INVALID_CHARACTER</code></dt>
 <dd>Throws if either of the following are true:
 <ul>
  <li>The processing instruction <code>target</code> is invalid — it should be a valid <em><a class="external" href="https://www.w3.org/TR/REC-xml/#dt-name" rel="external">XML name</a></em> that doesn't contain "xml", "XML", or any case combination of the two, other than standardized ones such as <code>&lt;?xml-stylesheet ?&gt;</code>.</li>
  <li>The <em>closing processing instruction sequence</em> (<code>?&gt;</code>) is part of the <code>data</code>.</li>
 </ul>
 </dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush:js">var doc = new DOMParser().parseFromString('&lt;foo /&gt;', 'application/xml');
var pi = doc.createProcessingInstruction('xml-stylesheet', 'href="mycss.css" type="text/css"');

doc.insertBefore(pi, doc.firstChild);

console.log(new XMLSerializer().serializeToString(doc));
// Displays: &lt;?xml-stylesheet href="mycss.css" type="text/css"?&gt;&lt;foo/&gt;
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-document-createprocessinginstruction', 'createProcessingInstruction()')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td>No change</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM4', '#dom-document-createprocessinginstruction', 'createProcessingInstruction()')}}</td>
   <td>{{Spec2('DOM4')}}</td>
   <td>Added more explicit definition of how the <code><var>data</var></code> parameter is validated.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM3 Core', 'core.html#ID-135944439', 'createProcessingInstruction()')}}</td>
   <td>{{Spec2('DOM3 Core')}}</td>
   <td>Added note that the namespace of the target name is not checked whether it is well-formed, defined what is considered an illegal character for the target name and specified the returned {{domxref("ProcessingInstruction")}} object more precisely.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 Core', 'core.html#ID-135944439', 'createProcessingInstruction()')}}</td>
   <td>{{Spec2('DOM2 Core')}}</td>
   <td>No change</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM1', 'level-one-core.html#ID-135944439', 'createProcessingInstruction()')}}</td>
   <td>{{Spec2('DOM1')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Document.createProcessingInstruction")}}</p>
